"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parse = void 0;
const Cheerio = __importStar(require("cheerio"));
const F = __importStar(require("fp-ts/function"));
const O = __importStar(require("fp-ts/Option"));
const FS = __importStar(require("fs/promises"));
const marked_1 = __importDefault(require("marked"));
const Path = __importStar(require("path"));
const Rx = __importStar(require("rxjs"));
const RxO = __importStar(require("rxjs/operators"));
const Additional = __importStar(require("./additional"));
const Aliases = __importStar(require("./aliases"));
const Blacklist = __importStar(require("./blacklist"));
const Endpoints = __importStar(require("./endpoints"));
const Enums = __importStar(require("./enums"));
const Flags = __importStar(require("./flags"));
const Gateway = __importStar(require("./gateway"));
const Structures = __importStar(require("./structures"));
const FSU = __importStar(require("./utils/fs"));
const parseMarkdown = (src) => Cheerio.load((0, marked_1.default)(src, { sanitize: false }));
const parse = (repoPath) => {
    const API_REPO_PATH = Path.resolve(repoPath);
    const API_DOCS_PATH = Path.join(API_REPO_PATH, "docs");
    const docs$ = FSU.files$(API_DOCS_PATH).pipe(RxO.filter((file) => Path.extname(file) === ".md"), RxO.flatMap((file) => Rx.zip(Rx.of(Path.relative(API_DOCS_PATH, file)), FS.readFile(file).then((blob) => {
        const markdown = blob.toString();
        return [parseMarkdown(markdown), markdown];
    }))), RxO.share());
    const filteredDocs$ = docs$.pipe(RxO.filter(([file]) => /^(interactions|resources|topics\/(gateway|permissions|teams|opcodes))/i.test(file)));
    const gatewayDocs$ = docs$.pipe(RxO.filter(([file]) => /^topics\/gateway/i.test(file)));
    const gateway$ = gatewayDocs$.pipe(RxO.flatMap(([_file, [$]]) => Gateway.fromDocument($)));
    const endpoints$ = filteredDocs$.pipe(RxO.flatMap(([file, [_, md]]) => Endpoints.fromDocument(md, file)));
    const structures$ = Rx.merge(Rx.from(Additional.structures()), filteredDocs$.pipe(RxO.flatMap(([file, [$]]) => Structures.fromDocument($, { file })), RxO.filter(({ identifier }) => !Blacklist.list.includes(identifier))), endpoints$.pipe(RxO.flatMap(({ params, response }) => [
        F.pipe(params, O.map(({ structures }) => structures)),
        F.pipe(response, O.map(({ structures }) => structures)),
    ]), RxO.filter(O.isSome), RxO.flatMap((params) => params.value), RxO.filter(({ identifier }) => !Blacklist.list.includes(identifier)))).pipe(RxO.filter(({ fields }) => fields.length > 0), RxO.distinct(({ identifier }) => identifier));
    const flags$ = Rx.merge(filteredDocs$.pipe(RxO.flatMap(([file, [$]]) => Flags.fromDocument($, file)), RxO.filter(({ identifier }) => !Blacklist.list.includes(identifier))), gatewayDocs$.pipe(RxO.flatMap(([_file, [$]]) => Gateway.intents($))));
    const enums$ = filteredDocs$.pipe(RxO.flatMap(([file, [$]]) => Enums.fromDocument($, file)), RxO.filter(({ identifier }) => !Blacklist.list.includes(identifier)));
    const aliases$ = Rx.merge(Rx.from(Aliases.list), gatewayDocs$.pipe(RxO.flatMap(([_file, [_, md]]) => Gateway.events(md)), RxO.map(({ identifier, payload }) => ({
        identifier,
        nullable: false,
        types: [payload],
    }))), endpoints$.pipe(RxO.flatMap(({ params, response }) => [params, response]), RxO.filter(O.isSome), RxO.map((p) => p.value), RxO.filter(({ structures }) => structures.length > 1), RxO.map(({ structures, identifier }) => ({
        identifier,
        nullable: false,
        array: false,
        combinator: "or",
        types: structures.map((s) => s.identifier),
    })))).pipe(RxO.distinct(({ identifier }) => identifier));
    return {
        aliases$,
        endpoints$,
        enums$,
        flags$,
        gateway$,
        structures$,
    };
};
exports.parse = parse;
